# Introduction to Video Capture and Playback

## Samples

This package consists of the 4 code samples from the Introduction to Video Capture and Playback presentation.

1. DeckLinkIterator (C++) - All Platforms
2. DeckLinkDiscovery (C#) - Windows only
3. DeckLinkCapture (C#) - Windows only
4. ScheduledPlayback (C++) - All platforms

## Prerequisites

### Linux (Ubuntu) build environment

* GCC etc. `sudo apt-get install build-essential`
* CMake `sudo apt-get install cmake`

### Mac build environment

* Xcode > 8.0 (App Store)
* CMake (download installer from cmake.org)

### Windows build environment

* Visual Studio 2017 (Community Edition is fine), with C++ and .NET Framework support installed
* CMake (download installer from cmake.org)

### Desktop Video Software

* Download Desktop Video 10.11.4 from https://www.blackmagicdesign.com/developer/product/capture-and-playback.  Follow steps to install software.
* All samples have been verified against 10.11.4.

### DeckLink SDK

* Download Desktop Video SDK 10.11.4 from https://www.blackmagicdesign.com/developer/product/capture-and-playback and extract archive under project directory
* If Desktop Video SDK is extracted outside of the project directory, update the -DDECKLINK_SDK_INCLUDE_DIR in the cmake command.

### DeckLink Hardware

* DeckLink device capable of capture and playback e.g. Intensity Pro 4K, DeckLink Extreme 12G, UltraStudio 4K

## Building Samples

### Linux Build

Refer to BuildLinux.sh script.

    mkdir build
    cd build
    cmake -DDECKLINK_SDK_INCLUDE_DIR=$(pwd)/Blackmagic\ DeckLink\ SDK\ 10.11.4/Linux/include ..
    cmake --build . --config Release

### Mac Build

Refer to BuildMac.sh script.

    mkdir build
    cd build
    cmake -G Xcode -DDECKLINK_SDK_INCLUDE_DIR=$(pwd)/Blackmagic\ DeckLink\ SDK\ 10.11.4/Mac/include ..
    cmake --build . --config Release

### Windows Build

Refer to BuildWin.bat batch file.

    mkdir build
    cd build
    cmake -G "Visual Studio 15 2017" -A x64 -DDECKLINK_SDK_INCLUDE_DIR="%cd%\..\Blackmagic DeckLink SDK 10.11.4\Win\include" ..
    cmake --build . --config Release
